/// @cond EO_CXX_EO_IMPL

inline void elm_pan::gravity_get(double* x_, double* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_gravity_get(x_, y_));
}

inline void elm_pan::gravity_set(double x_, double y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_gravity_set(x_, y_));
}

inline void elm_pan::pos_get(Evas_Coord* x_, Evas_Coord* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_pos_get(x_, y_));
}

inline void elm_pan::pos_set(Evas_Coord x_, Evas_Coord y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_pos_set(x_, y_));
}

inline void elm_pan::content_size_get(Evas_Coord* w_, Evas_Coord* h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_content_size_get(w_, h_));
}

inline void elm_pan::pos_min_get(Evas_Coord* x_, Evas_Coord* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_pos_min_get(x_, y_));
}

inline void elm_pan::pos_max_get(Evas_Coord* x_, Evas_Coord* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_pos_max_get(x_, y_));
}

inline void eo_cxx::elm_pan::gravity_get(double* x_, double* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_gravity_get(x_, y_));
}

inline void eo_cxx::elm_pan::gravity_set(double x_, double y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_gravity_set(x_, y_));
}

inline void eo_cxx::elm_pan::pos_get(Evas_Coord* x_, Evas_Coord* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_pos_get(x_, y_));
}

inline void eo_cxx::elm_pan::pos_set(Evas_Coord x_, Evas_Coord y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_pos_set(x_, y_));
}

inline void eo_cxx::elm_pan::content_size_get(Evas_Coord* w_, Evas_Coord* h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_content_size_get(w_, h_));
}

inline void eo_cxx::elm_pan::pos_min_get(Evas_Coord* x_, Evas_Coord* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_pos_min_get(x_, y_));
}

inline void eo_cxx::elm_pan::pos_max_get(Evas_Coord* x_, Evas_Coord* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_pan_pos_max_get(x_, y_));
}

inline ::eo_cxx::elm_pan::operator ::elm_pan() const
{
   return *static_cast<::elm_pan const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_pan::operator ::elm_pan&()
{
   return *static_cast<::elm_pan*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_pan::operator ::elm_pan const&() const
{
   return *static_cast<::elm_pan const*>(static_cast<void const*>(this));
}

template <typename T>
void _elm_pan_gravity_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* x_, double* y_)
{
   try
      {
         static_cast<T*>(self->this_)->gravity_get(x_, y_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_pan_gravity_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double x_, double y_)
{
   try
      {
         static_cast<T*>(self->this_)->gravity_set(x_, y_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_pan_pos_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_)
{
   try
      {
         static_cast<T*>(self->this_)->pos_get(x_, y_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_pan_pos_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_)
{
   try
      {
         static_cast<T*>(self->this_)->pos_set(x_, y_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_pan_content_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* w_, Evas_Coord* h_)
{
   try
      {
         static_cast<T*>(self->this_)->content_size_get(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_pan_pos_min_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_)
{
   try
      {
         static_cast<T*>(self->this_)->pos_min_get(x_, y_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_pan_pos_max_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_)
{
   try
      {
         static_cast<T*>(self->this_)->pos_max_get(x_, y_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_pan >
{
   template <typename T>
   struct type
         : virtual operations< ::evas::smart_clipped >::template type<T>
   {
      virtual void gravity_get(double* x_, double* y_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_gravity_get(x_, y_));
      }

      virtual void gravity_set(double x_, double y_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_gravity_set(x_, y_));
      }

      virtual void pos_get(Evas_Coord* x_, Evas_Coord* y_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_pos_get(x_, y_));
      }

      virtual void pos_set(Evas_Coord x_, Evas_Coord y_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_pos_set(x_, y_));
      }

      virtual void content_size_get(Evas_Coord* w_, Evas_Coord* h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_content_size_get(w_, h_));
      }

      virtual void pos_min_get(Evas_Coord* x_, Evas_Coord* y_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_pos_min_get(x_, y_));
      }

      virtual void pos_max_get(Evas_Coord* x_, Evas_Coord* y_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_pos_max_get(x_, y_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_pan >
{
   static constexpr int value = 
#if defined(ELM_PAN_PROTECTED) && defined(ELM_PAN_BETA)
      7
#elif defined(ELM_PAN_PROTECTED)
      7
#elif defined(ELM_PAN_BETA)
      7
#else
      7
#endif
      + operation_description_class_size<::evas::smart_clipped >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_pan>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::_elm_pan_gravity_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_gravity_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_pan_gravity_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_gravity_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_pan_pos_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_pos_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_pan_pos_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_pos_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_pan_content_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_content_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_pan_pos_min_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_pos_min_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_pan_pos_max_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_pos_max_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::smart_clipped>(), &ops[operation_description_class_size< ::elm_pan >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_pan>)
{
   return (ELM_PAN_CLASS);
}

} } }

/// @endcond

